diff -ruN freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c
--- freeswan-1.9.orig/klips/net/ipsec/pfkey_v2_parser.c	Mon Feb 26 19:51:01 2001
+++ freeswan-1.9/klips/net/ipsec/pfkey_v2_parser.c	Wed May 16 10:57:20 2001
@@ -2894,13 +3065,13 @@
 		)) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_delflow_parse: "
 			    "failed to build the x_delflow reply message extensions\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 		
 	if((error = pfkey_msg_build(&pfkey_reply, extensions_reply, EXT_BITS_OUT))) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_delflow_parse: "
 			    "failed to build the x_delflow reply message\n");
-		goto errlab;
+		SENDERR(-error);
 	}
 	
 	for(pfkey_socketsp = pfkey_open_sockets;
@@ -2908,22 +3079,29 @@
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_delflow_parse: "
-				    "sending up x_delflow reply message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up x_delflow reply message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_x_delflow_parse: "
-			    "sending up x_delflow reply message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up x_delflow reply message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
-	ipsec_tdbwipe(extr->tdb);
-
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_x_delflow_parse: "
 		    "extr->tdb cleaned up and freed.\n");
 
  errlab:
+	if (pfkey_reply) {
+		pfkey_msg_free(&pfkey_reply);
+	}
+	pfkey_extensions_free(extensions_reply);
 	return error;
 }
 
@@ -2947,10 +3125,18 @@
 	struct sadb_msg *pfkey_msg = NULL;
 	struct socket_list *pfkey_socketsp;
 	int error = 0;
-	uint8_t satype = proto2satype(tdbp->tdb_said.proto);
+	uint8_t satype;
 
 	pfkey_extensions_init(extensions);
 
+	if(!(satype = proto2satype(tdbp->tdb_said.proto))) {
+		KLIPS_PRINT(debug_pfkey,
+			    "klips_debug:pfkey_expire: "
+			    "satype lookup for protocol %d lookup failed.\n", 
+			    tdbp->tdb_said.proto);
+		SENDERR(EINVAL);
+	}
+	
 	if(!pfkey_open_sockets) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: "
 			    "no sockets listening.\n");
@@ -3007,16 +3193,16 @@
 							      0,
 							      tdbp->tdb_addr_d),
 				  extensions))) {
-		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: failed to "
-			    "build the expire message extensions\n");
+		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: "
+			    "failed to build the expire message extensions\n");
 		spin_unlock(&tdb_lock);
 		goto errlab;
 	}
 	
 	if ((error = pfkey_msg_build(&pfkey_msg, extensions, EXT_BITS_OUT))) {
-		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: failed to "
-			    "build the expire message\n");
-		goto errlab;
+		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: "
+			    "failed to build the expire message\n");
+		SENDERR(-error);
 	}
 	
 	for(pfkey_socketsp = pfkey_open_sockets;
@@ -3024,13 +3210,19 @@
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_msg))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: "
-				    "sending up expire message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up expire message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_expire: "
-			    "sending up expire message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up expire message for satype=%d(%s) (proto=%d) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    tdbp->tdb_said.proto,
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -3063,7 +3255,7 @@
 		  57600, 86400, 57600, 86400 }
 	};
        
-	/* This should not be hard-coded.  It should be taken from the spdb */
+	/* XXX This should not be hard-coded.  It should be taken from the spdb */
 	uint8_t satype = SADB_SATYPE_ESP;
 
 	pfkey_extensions_init(extensions);
@@ -3077,8 +3269,9 @@
 
 	if(!(pfkey_registered_sockets[satype])) {
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: "
-			    "no sockets registered for SAtype=%d.\n",
-			    satype);
+			    "no sockets registered for SAtype=%d(%s).\n",
+			    satype,
+			    satype2name(satype));
 		SENDERR(EPROTONOSUPPORT);
 	}
 	
@@ -3146,15 +3339,15 @@
 							   &(comb[0])),
 				  extensions)
 		)) {
-		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: failed to "
-			    "build the acquire message extensions\n");
-		goto errlab;
+		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: "
+			    "failed to build the acquire message extensions\n");
+		SENDERR(-error);
 	}
 	
 	if ((error = pfkey_msg_build(&pfkey_msg, extensions, EXT_BITS_OUT))) {
-		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: failed to "
-			    "build the acquire message\n");
-		goto errlab;
+		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: "
+			    "failed to build the acquire message\n");
+		SENDERR(-error);
 	}
 	
 	/* this should go to all registered sockets for that satype only */
@@ -3163,13 +3356,18 @@
 	    pfkey_socketsp = pfkey_socketsp->next) {
 		if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_msg))) {
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: "
-				    "sending up acquire message for satype=%d to socket=%p failed with error=%d.\n",
-				    satype, pfkey_socketsp->socketp, error);
-			goto errlab;
+				    "sending up acquire message for satype=%d(%s) to socket=%p failed with error=%d.\n",
+				    satype,
+				    satype2name(satype),
+				    pfkey_socketsp->socketp,
+				    error);
+			SENDERR(-error);
 		}
 		KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_acquire: "
-			    "sending up acquire message for satype=%d to socket=%p succeeded.\n",
-			    satype, pfkey_socketsp->socketp);
+			    "sending up acquire message for satype=%d(%s) to socket=%p succeeded.\n",
+			    satype,
+			    satype2name(satype),
+			    pfkey_socketsp->socketp);
 	}
 	
  errlab:
@@ -3243,12 +3441,13 @@
 	int msg_type = pfkey_msg->sadb_msg_type;
 	int seq = pfkey_msg->sadb_msg_seq;
 
-	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: building reply"
-					" with type: %d\n", msg_type);
+	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: "
+		    "building reply with type: %d\n",
+		    msg_type);
 	pfkey_extensions_init(extensions);
 	if (!extr || !extr->tdb) {
-			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: bad TDB"
-							"passed\n");
+			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: "
+				    "bad TDB passed\n");
 			return EINVAL;
 	}
 	error = pfkey_safe_build(pfkey_msg_hdr_build(&extensions[0],
@@ -3302,10 +3501,13 @@
 		return EINVAL;
 	}
 
-	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: built extensions"
-		    ", proceed to build the message\n");
-	KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_build_reply: extensions[1]="
-		    " %p\n", extensions[1]);
+	KLIPS_PRINT(debug_pfkey,
+		    "klips_debug:pfkey_build_reply: "
+		    "built extensions, proceed to build the message\n");
+	KLIPS_PRINT(debug_pfkey,
+		    "klips_debug:pfkey_build_reply: "
+		    "extensions[1]= %p\n",
+		    extensions[1]);
 	error = pfkey_msg_build(pfkey_reply, extensions, EXT_BITS_OUT);
 	pfkey_extensions_free(extensions);
 
@@ -3323,12 +3525,13 @@
 	
 	pfkey_extensions_init(extensions);
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_msg_interp: parsing message "
-		    "ver=%d, type=%d, errno=%d, satype=%d, len=%d, res=%d, seq=%d, pid=%d.\n", 
+		    "klips_debug:pfkey_msg_interp: "
+		    "parsing message ver=%d, type=%d, errno=%d, satype=%d(%s), len=%d, res=%d, seq=%d, pid=%d.\n", 
 		    pfkey_msg->sadb_msg_version,
 		    pfkey_msg->sadb_msg_type,
 		    pfkey_msg->sadb_msg_errno,
 		    pfkey_msg->sadb_msg_satype,
+		    satype2name(pfkey_msg->sadb_msg_satype),
 		    pfkey_msg->sadb_msg_len,
 		    pfkey_msg->sadb_msg_reserved,
 		    pfkey_msg->sadb_msg_seq,
@@ -3337,18 +3540,22 @@
 	if((error = pfkey_alloc_tdb(&(extr.tdb)))) {
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_msg_interp: "
-			    "something's really wrong, extr.tdb=%p should be NULL.\n", extr.tdb);
+			    "something's really wrong, extr.tdb=%p should be NULL.\n",
+			    extr.tdb);
 		SENDERR(-error);
 	}
 
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_msg_interp: "
-		    "allocated extr->tdb=%p.\n", extr.tdb);
+		    "allocated extr->tdb=%p.\n",
+		    extr.tdb);
 	
 	if(pfkey_msg->sadb_msg_satype > SADB_SATYPE_MAX) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_msg_interp: satype %d > max %d\n", 
-			    pfkey_msg->sadb_msg_satype, SADB_SATYPE_MAX);
+			    "klips_debug:pfkey_msg_interp: "
+			    "satype %d > max %d\n", 
+			    pfkey_msg->sadb_msg_satype,
+			    SADB_SATYPE_MAX);
 		SENDERR(EINVAL);
 	}
 	
@@ -3358,16 +3565,21 @@
 	case SADB_ADD:
 	case SADB_DELETE:
 	case SADB_X_GRPSA:
+	case SADB_X_ADDFLOW:
 		if(!(extr.tdb->tdb_said.proto = satype2proto(pfkey_msg->sadb_msg_satype))) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_msg_interp: satype %d lookup failed.\n", 
+				    "klips_debug:pfkey_msg_interp: "
+				    "satype %d lookup failed.\n", 
 				    pfkey_msg->sadb_msg_satype);
 			SENDERR(EINVAL);
+		} else {
+			KLIPS_PRINT(debug_pfkey,
+				    "klips_debug:pfkey_msg_interp: "
+				    "satype %d lookups to proto=%d.\n", 
+				    pfkey_msg->sadb_msg_satype,
+				    extr.tdb->tdb_said.proto);
 		}
 		break;
-	case SADB_X_ADDFLOW:
-		extr.tdb->tdb_said.proto = satype2proto(pfkey_msg->sadb_msg_satype);
-		break;
 	default:
 	}
 	
@@ -3376,7 +3588,8 @@
 	if((error = pfkey_msg_parse(pfkey_msg, NULL, extensions, EXT_BITS_IN)))
 	{
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_msg_interp: message parsing failed with error %d.\n",
+			    "klips_debug:pfkey_msg_interp: "
+			    "message parsing failed with error %d.\n",
 			    error); 
 		SENDERR(-error);
 	}
@@ -3390,8 +3603,10 @@
 				    i, extensions[i], ext_processors[i]);
 			if((error = ext_processors[i](extensions[i], &extr))) {
 				KLIPS_PRINT(debug_pfkey,
-					    "klips_debug:pfkey_msg_interp: extension processing for type %d failed with error %d.\n",
-					    i,error); 
+					    "klips_debug:pfkey_msg_interp: "
+					    "extension processing for type %d failed with error %d.\n",
+					    i,
+					    error); 
 				SENDERR(-error);
 			}
 			
@@ -3407,7 +3622,8 @@
 		    msg_parsers[pfkey_msg->sadb_msg_type]); 
 	if((error = msg_parsers[pfkey_msg->sadb_msg_type](sk, extensions, &extr))) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_msg_interp: message parsing failed with error %d.\n",
+			    "klips_debug:pfkey_msg_interp: "
+			    "message parsing failed with error %d.\n",
 			    error); 
 		SENDERR(-error);
 	}
@@ -3419,13 +3635,69 @@
 	}
 #endif	
  errlab:
+	if(extr.tdb != NULL) {
+		ipsec_tdbwipe(extr.tdb);
+	}
+	if(extr.tdb2 != NULL) {
+		ipsec_tdbwipe(extr.tdb2);
+	}
+	if (extr.eroute != NULL) {
+		kfree(extr.eroute);
+	}
 	return(error);
 }
 
 /*
  * $Log: pfkey_v2_parser.c,v $
- * Revision 1.68.2.1  2001/02/27 00:51:01  henry
- * message improvements
+ * Revision 1.80  2001/05/03 19:43:59  rgb
+ * Check error return codes for all build function calls.
+ * Standardise on SENDERR() macro.
+ *
+ * Revision 1.79  2001/04/20 21:09:16  rgb
+ * Cleaned up fixed tdbwipes.
+ * Free pfkey_reply and clean up extensions_reply for grpsa, addflow and
+ * delflow (Per Cederqvist) plugging memleaks.
+ *
+ * Revision 1.78  2001/04/19 19:02:39  rgb
+ * Fixed extr.tdb freeing, stealing it for getspi, update and add.
+ * Refined a couple of spinlocks, fixed the one in update.
+ *
+ * Revision 1.77  2001/04/18 20:26:16  rgb
+ * Wipe/free eroute and both tdbs from extr at end of pfkey_msg_interp()
+ * instead of inside each message type parser.  This fixes two memleaks.
+ *
+ * Revision 1.76  2001/04/17 23:51:18  rgb
+ * Quiet down pfkey_x_debug_process().
+ *
+ * Revision 1.75  2001/03/29 01:55:05  rgb
+ * Fixed pfkey key init memleak.
+ * Fixed pfkey encryption key debug output.
+ *
+ * Revision 1.74  2001/03/27 05:29:14  rgb
+ * Debug output cleanup/silencing.
+ *
+ * Revision 1.73  2001/02/28 05:03:28  rgb
+ * Clean up and rationalise startup messages.
+ *
+ * Revision 1.72  2001/02/27 22:24:56  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.71  2001/02/27 06:59:30  rgb
+ * Added satype2name() conversions most places satype is debug printed.
+ *
+ * Revision 1.70  2001/02/26 22:37:08  rgb
+ * Fixed 'unknown proto' INT bug in new code.
+ * Added satype to protocol debugging instrumentation.
+ *
+ * Revision 1.69  2001/02/26 19:57:51  rgb
+ * Re-formatted debug output (split lines, consistent spacing).
+ * Fixed as yet undetected FLUSH bug which called ipsec_tdbcleanup()
+ * with an satype instead of proto.
+ * Checked for satype consistency and fixed minor bugs.
+ * Fixed undetected ungrpspi bug that tried to upmsg a second tdb.
+ * Check for satype sanity in pfkey_expire().
+ * Added satype sanity check to addflow.
  *
  * Revision 1.68  2001/02/12 23:14:40  rgb
  * Remove double spin lock in pfkey_expire().
diff -ruN freeswan-1.9.orig/klips/net/ipsec/radij.c freeswan-1.9/klips/net/ipsec/radij.c
--- freeswan-1.9.orig/klips/net/ipsec/radij.c	Sun Nov  5 23:35:21 2000
+++ freeswan-1.9/klips/net/ipsec/radij.c	Wed May 16 10:57:20 2001
@@ -1,4 +1,4 @@
-char radij_c_version[] = "RCSID $Id: radij.c,v 1.31 2000/11/06 04:35:21 rgb Exp $";
+char radij_c_version[] = "RCSID $Id: radij.c,v 1.34 2001/05/03 19:44:26 rgb Exp $";
 
 /*
  * This file is defived from ${SRC}/sys/net/radix.c of BSD 4.4lite
@@ -213,7 +213,8 @@
 	 * See if we match exactly as a host destination
 	 */
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:rj_match: * See if we match exactly as a host destination\n");
+		    "klips_debug:rj_match: "
+		    "* See if we match exactly as a host destination\n");
 	
 	cp += off; cp2 = t->rj_key + off; cplim = v + vlen;
 	for (; cp < cplim; cp++, cp2++)
@@ -230,7 +231,8 @@
 	matched_off = cp - v;
 	saved_t = t;
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:rj_match: ** try to match a leaf, t=0x%p\n", t);
+		    "klips_debug:rj_match: "
+		    "** try to match a leaf, t=0x%p\n", t);
 	do {
 	    if (t->rj_mask) {
 		/*
@@ -251,13 +253,17 @@
 	t = saved_t;
 	/* start searching up the tree */
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:rj_match: *** start searching up the tree, t=0x%p\n", t);
+		    "klips_debug:rj_match: "
+		    "*** start searching up the tree, t=0x%p\n",
+		    t);
 	do {
 		register struct radij_mask *m;
 		
 		t = t->rj_p;
 		KLIPS_PRINT(debug_radij,
-			    "klips_debug:rj_match: **** t=0x%p\n", t);
+			    "klips_debug:rj_match: "
+			    "**** t=0x%p\n",
+			    t);
 		if ((m = t->rj_mklist)) {
 			/*
 			 * After doing measurements here, it may
@@ -271,7 +277,9 @@
 				cp2 = mstart;
 				cp3 = m->rm_mask + off;
 				KLIPS_PRINT(debug_radij,
-					    "klips_debug:rj_match: ***** cp2=0x%p cp3=0x%p\n", cp2, cp3);
+					    "klips_debug:rj_match: "
+					    "***** cp2=0x%p cp3=0x%p\n",
+					    cp2, cp3);
 				for (cp = v + off; cp < cplim;)
 					*cp2++ =  *cp++ & *cp3++;
 				x = rj_search(maskedKey, t);
@@ -285,7 +293,8 @@
 		}
 	} while (t != top);
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:rj_match: ***** not found.\n");
+		    "klips_debug:rj_match: "
+		    "***** not found.\n");
 	return 0;
 };
 		
@@ -363,7 +372,7 @@
 	} while (b > (unsigned) x->rj_b); /* x->rj_b < b && x->rj_b >= 0 */
 #ifdef RJ_DEBUG
 	if (rj_debug)
-		printk("klips_debug:Going In:\n"), traverse(p);
+		printk("klips_debug:rj_insert: Going In:\n"), traverse(p);
 #endif /* RJ_DEBUG */
 	t = rj_newpair(v_arg, b, nodes); tt = t->rj_l;
 	if ((cp[p->rj_off] & p->rj_bmask) == 0)
@@ -378,7 +387,7 @@
 	}
 #ifdef RJ_DEBUG
 	if (rj_debug)
-		printk("klips_debug:Coming out:\n"), traverse(p);
+		printk("klips_debug:rj_insert: Coming out:\n"), traverse(p);
 #endif /* RJ_DEBUG */
     }
 	return (tt);
@@ -460,7 +469,7 @@
 		if (Bcmp(netmask, x->rj_key, mlen) != 0) {
 			x = rj_addmask(netmask, 0, top->rj_off);
 			if (x == 0)
-				return /* (0) rgb */ ENOMEM;
+				return /* (0) rgb */ -ENOMEM;
 		}
 		netmask = x->rj_key;
 		b = -1 - x->rj_b;
@@ -472,7 +481,7 @@
 	if (keyduplicated) {
 		do {
 			if (tt->rj_mask == netmask)
-				return /* (0) rgb */ ENXIO;
+				return /* (0) rgb */ -ENXIO;
 			t = tt;
 			if (netmask == 0 ||
 			    (tt->rj_mask && rj_refines(netmask, tt->rj_mask)))
@@ -569,7 +578,8 @@
 	}
 	MKGet(m);
 	if (m == 0) {
-		printk("klips_debug:Mask for route not entered\n");
+		printk("klips_debug:rj_addroute: "
+		       "Mask for route not entered\n");
 		return /* (tt) rgb */ 0;
 	}
 	Bzero(m, sizeof *m);
@@ -617,7 +627,8 @@
 	if (tt->rj_mask == 0 || (saved_m = m = tt->rj_mklist) == 0)
 		goto on1;
 	if (m->rm_mask != tt->rj_mask) {
-		printk("klips_debug:rj_delete: inconsistent annotation\n");
+		printk("klips_debug:rj_delete: "
+		       "inconsistent annotation\n");
 		goto on1;
 	}
 	if (--m->rm_refs >= 0)
@@ -637,7 +648,8 @@
 			break;
 		}
 	if (m == 0)
-		printk("klips_debug:rj_delete: couldn't find our annotation\n");
+		printk("klips_debug:rj_delete: "
+		       "couldn't find our annotation\n");
 on1:
 	/*
 	 * Eliminate us from tree
@@ -658,7 +670,8 @@
 			for (x = p = saved_tt; p && p->rj_dupedkey != tt;)
 				p = p->rj_dupedkey;
 			if (p) p->rj_dupedkey = tt->rj_dupedkey;
-			else printk("klips_debug:rj_delete: couldn't find us\n");
+			else printk("klips_debug:rj_delete: "
+				       "couldn't find us\n");
 		}
 		t = tt + 1;
 		if  (t->rj_flags & RJF_ACTIVE) {
@@ -691,8 +704,8 @@
 					x->rj_mklist = 0;
 					MKFree(m);
 				} else 
-					printk("klips_debug:%s %p at %p\n",
-					    "rj_delete: Orphaned Mask", m, x);
+					printk("klips_debug:rj_delete: "
+					    "Orphaned Mask %p at %p\n", m, x);
 				m = mm;
 			}
 		}
@@ -729,7 +742,7 @@
 	register struct radij_node *rn;
 
 	if(!h || !f /* || !w */) {
-		return -1;
+		return -ENODATA;
 	}
 
 	rn = h->rnh_treetop;
@@ -744,9 +757,14 @@
 	for (;;) {
 #ifdef CONFIG_IPSEC_DEBUG
 		if(debug_radij) {
-			printk("klips_debug:RN_WALKTREE: for: rn=%p rj_b=%d rj_flags=%x", rn, rn->rj_b, rn->rj_flags);
+			printk("klips_debug:rj_walktree: "
+			       "for: rn=%p rj_b=%d rj_flags=%x",
+			       rn,
+			       rn->rj_b,
+			       rn->rj_flags);
 			rn->rj_b >= 0 ?
-				printk(" node off=%x\n", rn->rj_off) :
+				printk(" node off=%x\n",
+				       rn->rj_off) :
 				printk(" leaf key = %08x->%08x\n",
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_src.s_addr),
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_dst.s_addr))
@@ -763,9 +781,14 @@
 		next = rn;
 #ifdef CONFIG_IPSEC_DEBUG
 		if(debug_radij) {
-			printk("klips_debug:RN_WALKTREE: processing leaves, rn=%p rj_b=%d rj_flags=%x", rn, rn->rj_b, rn->rj_flags);
+			printk("klips_debug:rj_walktree: "
+			       "processing leaves, rn=%p rj_b=%d rj_flags=%x",
+			       rn,
+			       rn->rj_b,
+			       rn->rj_flags);
 			rn->rj_b >= 0 ?
-				printk(" node off=%x\n", rn->rj_off) :
+				printk(" node off=%x\n",
+				       rn->rj_off) :
 				printk(" leaf key = %08x->%08x\n",
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_src.s_addr),
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_dst.s_addr))
@@ -777,10 +800,15 @@
 			base = rn->rj_dupedkey;
 #ifdef CONFIG_IPSEC_DEBUG
 			if(debug_radij) {
-				printk("klips_debug:RN_WALKTREE: while: base=%p rn=%p rj_b=%d rj_flags=%x",
-				       base, rn, rn->rj_b, rn->rj_flags);
+				printk("klips_debug:rj_walktree: "
+				       "while: base=%p rn=%p rj_b=%d rj_flags=%x",
+				       base,
+				       rn,
+				       rn->rj_b,
+				       rn->rj_flags);
 				rn->rj_b >= 0 ?
-					printk(" node off=%x\n", rn->rj_off) :
+					printk(" node off=%x\n",
+					       rn->rj_off) :
 					printk(" leaf key = %08x->%08x\n",
 					       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_src.s_addr),
 					       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_dst.s_addr))
@@ -807,7 +835,7 @@
 	if (*head)
 		return (1);
 	R_Malloc(rnh, struct radij_node_head *, sizeof (*rnh));
-	if (rnh == 0)
+	if (rnh == NULL)
 		return (0);
 	Bzero(rnh, sizeof (*rnh));
 	*head = rnh;
@@ -834,7 +862,8 @@
 	char *cp, *cplim;
 
 	if (maj_keylen == 0) {
-		printk("klips_debug:rj_init: radij functions require maj_keylen be set\n");
+		printk("klips_debug:rj_init: "
+		       "radij functions require maj_keylen be set\n");
 		return;
 	}
 	R_Malloc(rj_zeroes, char *, 3 * maj_keylen);
@@ -855,7 +884,8 @@
 	int i;
 	
 	if (rn == NULL){
-		printk("klips_debug:rj_preorder: NULL pointer\n");
+		printk("klips_debug:rj_preorder: "
+		       "NULL pointer\n");
 		return;
 	}
 	
@@ -865,27 +895,29 @@
 		printk("klips_debug:");
 		for (i=0; i<l; i++)
 			printk("*");
-		printk(" off = %d\n", rn->rj_off);
+		printk(" off = %d\n",
+		       rn->rj_off);
 	} else {
 		printk("klips_debug:");
 		for (i=0; i<l; i++)
 			printk("@");
-		printk(" flags = %x", (u_int)rn->rj_flags);
+		printk(" flags = %x",
+		       (u_int)rn->rj_flags);
 		if (rn->rj_flags & RJF_ACTIVE) {
-			printk(" @key = %p", rn->rj_key);
-			
+			printk(" @key = %p",
+			       rn->rj_key);
 			printk(" key = %08x->%08x",
 			       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_src.s_addr),
 			       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_key)->sen_ip_dst.s_addr));
-
-			printk(" @mask = %p", rn->rj_mask);
+			printk(" @mask = %p",
+			       rn->rj_mask);
 			if (rn->rj_mask)
 				printk(" mask = %08x->%08x",
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_mask)->sen_ip_src.s_addr),
 				       (u_int)ntohl(((struct sockaddr_encap *)rn->rj_mask)->sen_ip_dst.s_addr));
-		
 			if (rn->rj_dupedkey)
-				printk(" dupedkey = %08x", (u_int)rn->rj_dupedkey);
+				printk(" dupedkey = %08x",
+				       (u_int)rn->rj_dupedkey);
 		}
 		printk("\n");
 	}
@@ -951,6 +983,16 @@
 
 /*
  * $Log: radij.c,v $
+ * Revision 1.34  2001/05/03 19:44:26  rgb
+ * Fix sign of error return codes for rj_addroute().
+ *
+ * Revision 1.33  2001/02/27 22:24:56  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.32  2001/02/27 06:23:15  rgb
+ * Debug line splitting.
+ *
  * Revision 1.31  2000/11/06 04:35:21  rgb
  * Clear table *before* releasing other items in radijcleanup.
  *
diff -ruN freeswan-1.9.orig/klips/net/ipsec/sysctl_net_ipsec.c freeswan-1.9/klips/net/ipsec/sysctl_net_ipsec.c
--- freeswan-1.9.orig/klips/net/ipsec/sysctl_net_ipsec.c	Fri Sep 15 21:50:15 2000
+++ freeswan-1.9/klips/net/ipsec/sysctl_net_ipsec.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: sysctl_net_ipsec.c,v 1.10 2000/09/16 01:50:15 rgb Exp $
+ * RCSID $Id: sysctl_net_ipsec.c,v 1.11 2001/02/26 19:58:13 rgb Exp $
  */
 
 /* -*- linux-c -*-
@@ -44,9 +44,7 @@
 #endif /* CONFIG_IPSEC_DEBUG */
 
 extern int sysctl_ipsec_icmp;
-extern int sysctl_ipsec_no_eroute_pass;
 extern int sysctl_ipsec_inbound_policy_check;
-extern int sysctl_ipsec_opportunistic;
 extern int sysctl_ipsec_tos;
 
 enum {
@@ -65,10 +63,8 @@
 	NET_IPSEC_DEBUG_IPCOMP=12,
 #endif /* CONFIG_IPSEC_DEBUG */
 	NET_IPSEC_ICMP=13,
-	NET_IPSEC_NO_EROUTE_PASS=14,
-	NET_IPSEC_INBOUND_POLICY_CHECK=15,
-	NET_IPSEC_OPPORTUNISTIC=16,
-	NET_IPSEC_TOS=17
+	NET_IPSEC_INBOUND_POLICY_CHECK=14,
+	NET_IPSEC_TOS=15
 };
 
 static ctl_table ipsec_table[] = {
@@ -102,12 +98,8 @@
 #endif /* CONFIG_IPSEC_DEBUG */
 	{ NET_IPSEC_ICMP, "icmp", &sysctl_ipsec_icmp,
 	  sizeof(int), 0644, NULL, &proc_dointvec},    
-	{ NET_IPSEC_NO_EROUTE_PASS, "no_eroute_pass", &sysctl_ipsec_no_eroute_pass,
-	  sizeof(int), 0644, NULL, &proc_dointvec},    
 	{ NET_IPSEC_INBOUND_POLICY_CHECK, "inbound_policy_check", &sysctl_ipsec_inbound_policy_check,
 	  sizeof(int), 0644, NULL, &proc_dointvec},    
-	{ NET_IPSEC_OPPORTUNISTIC, "opportunistic", &sysctl_ipsec_opportunistic,
-	  sizeof(int), 0644, NULL, &proc_dointvec},    
 	{ NET_IPSEC_TOS, "tos", &sysctl_ipsec_tos,
 	  sizeof(int), 0644, NULL, &proc_dointvec},    
 	{0}
@@ -143,6 +135,9 @@
 
 /*
  * $Log: sysctl_net_ipsec.c,v $
+ * Revision 1.11  2001/02/26 19:58:13  rgb
+ * Drop sysctl_ipsec_{no_eroute_pass,opportunistic}, replaced by magic SAs.
+ *
  * Revision 1.10  2000/09/16 01:50:15  rgb
  * Protect sysctl_ipsec_debug_ipcomp with compiler defines too so that the
  * linker won't blame rj_delete() for missing symbols.  ;->  Damn statics...
diff -ruN freeswan-1.9.orig/klips/net/ipsec/version.c freeswan-1.9/klips/net/ipsec/version.c
--- freeswan-1.9.orig/klips/net/ipsec/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/klips/net/ipsec/version.c	Thu May 17 14:34:12 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.17 2000/11/30 05:02:51 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix1";
diff -ruN freeswan-1.9.orig/klips/test/ipsec.funcs freeswan-1.9/klips/test/ipsec.funcs
--- freeswan-1.9.orig/klips/test/ipsec.funcs	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/klips/test/ipsec.funcs	Wed May 16 10:57:20 2001
@@ -0,0 +1,209 @@
+#!/bin/sh
+#
+# ipsec.func	This file contains functions for use by klips/test
+#		shell scripts.
+# Version:	0.0
+#
+# Author:	Richard Guy Briggs, <rgb@conscoop.ottawa.on.ca>
+#
+# Default search path:
+export PATH="/sbin:/usr/sbin:/usr/local/sbin:/bin:/usr/bin:/usr/local/bin"
+#
+# The following (environment) variables are expected to be set before
+# calling these functions as apropriate.
+#
+# net1=
+# net2=
+# gw1=
+# gw2=
+# h_mask=
+# n_mask=
+# ipsec_dev=
+# phys_dev=
+## iv=
+## esp_key=
+## ah_key=
+#
+# xform1a=
+# xform1b=
+# xform1c=
+# xform2a=
+# xform2b=
+# xform2c=
+#
+# spi1a=
+# spi1b=
+# spi1c=
+# spi2a=
+# spi2b=
+# spi2c=
+#
+
+# Setup module and interface
+#
+ipsec_setup() {
+	# Load the module
+	depmod -a
+	modprobe ipsec
+	# Attach and configure the interface
+	tncfg attach $ipsecdev $physdev
+	ifconfig $ipsecdev $gw1 
+}
+#
+# Clean up and unload the module
+ipsec_unload() {
+	ifconfig ipsec0 down
+	ifconfig ipsec1 down
+	rmmod ipsec
+}
+#
+# Display configuration from /proc/net/ipsec* filesystem.
+#
+ipsec_proc() {
+	echo /proc/net/ipsec-spi
+	cat /proc/net/ipsec-spi
+	echo
+	echo /proc/net/ipsec-route
+	cat /proc/net/ipsec-route
+}
+#
+# Setup a secure connection
+#
+ipsec_setconn() {
+case "$1" in
+	# Transport mode
+	trespah)
+		spi $gw1 $spi1a esp $xform1a i \
+			$iv $esp_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a esp $xform2a i \
+			$iv $esp_key
+		;;
+	trespahdel)
+		spi $gw1 $spi1a del
+
+		spi $gw2 $spi2a del
+
+		eroute del $gw1 $hmask $gw2 $hmask
+
+		route del $gw2
+		;;
+	trah)
+		spi $gw1 $spi1a ah $xform1a $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a ah $xform2a $ah_key
+		;;
+	tresp)
+		spi $gw1 $spi1a esp $xform1a $iv $esp_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+		spi $gw2 $spi2a esp $xform2a $iv $esp_key
+		;;
+	# Tunnel mode
+	tu)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $net2
+		route add -net $net2 dev ipsec0 gw $gw2
+
+		# forward path
+		eroute add $net1 $nmask \
+			$net2 $nmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	turoad)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0 gw $gw2a
+
+		# forward path
+		eroute add $net1 $nmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	turoad2)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $net2
+		route add -net $net2 dev ipsec0 gw $gw2
+
+		# forward path
+		eroute add $gw1 $hmask \
+			$net2 $nmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+	tugw)
+		# return path
+		spi $gw1 $spi1b esp $xform1b $iv $esp_key
+		spi $gw1 $spi1c ah $xform1c $ah_key
+
+		route del $gw2
+		route add -host $gw2 dev ipsec0
+
+		# forward path
+		eroute add $gw1 $hmask \
+			$gw2 $hmask \
+			$gw2 $spi2a
+
+		spi $gw2 $spi2a $xform2a \
+			$gw1 $gw2
+		spi $gw2 $spi2b esp $xform2b $iv $esp_key
+		spi $gw2 $spi2c ah $xform2c $ah_key
+
+		spigrp $gw2 $spi2a \
+			$gw2 $spi2b \
+			$gw2 $spi2c
+		;;
+esac
+}
diff -ruN freeswan-1.9.orig/klips/utils/Makefile freeswan-1.9/klips/utils/Makefile
--- freeswan-1.9.orig/klips/utils/Makefile	Fri Jun 30 02:20:25 2000
+++ freeswan-1.9/klips/utils/Makefile	Wed May 16 10:57:20 2001
@@ -30,8 +30,8 @@
 CFLAGS+= -Wbad-function-cast 
 
 ALL=spi eroute spigrp tncfg klipsdebug
-BINDIR=/usr/local/lib/ipsec
-MANTREE=/usr/local/man
+BINDIR=/usr/lib/ipsec
+MANTREE=/usr/man
 MANDIR8=$(MANTREE)/man8
 MANDIR5=$(MANTREE)/man5
 FREESWANLIB=../../lib/libfreeswan.a
@@ -40,11 +40,11 @@
 all: $(ALL)
 
 install: $(ALL)
-	$(INSTALL) $(ALL) $(BINDIR)
+	$(INSTALL) $(ALL) $(PREFIX)/$(BINDIR)
 	for f in $(addsuffix .8, $(ALL)) ; do \
-		$(INSTALL) $$f $(MANDIR8)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR8)/ipsec_$$f || exit 1 ; done
 	for f in $(addsuffix .5, $(ALL) version pf_key) ; do \
-		$(INSTALL) $$f $(MANDIR5)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR5)/ipsec_$$f || exit 1 ; done
 
 spi: spi.o
 	$(CC) $(DFLAGS) -o $@ $? $(FREESWANLIB)
diff -ruN freeswan-1.9.orig/klips/utils/version.c freeswan-1.9/klips/utils/version.c
--- freeswan-1.9.orig/klips/utils/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/klips/utils/version.c	Thu May 17 14:34:27 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.17 2000/11/30 05:02:51 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix1";
